<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [kibana-plugin-public](./kibana-plugin-public.md)

## kibana-plugin-public package

The Kibana Core APIs for client-side plugins.

A plugin's `public/index` file must contain a named import, `plugin`<!-- -->, that implements [PluginInitializer](./kibana-plugin-public.plugininitializer.md) which returns an object that implements [Plugin](./kibana-plugin-public.plugin.md)<!-- -->.

The plugin integrates with the core system via lifecycle events: `setup`<!-- -->, `start`<!-- -->, and `stop`<!-- -->. In each lifecycle method, the plugin will receive the corresponding core services available (either [CoreSetup](./kibana-plugin-public.coresetup.md) or [CoreStart](./kibana-plugin-public.corestart.md)<!-- -->) and any interfaces returned by dependency plugins' lifecycle method. Anything returned by the plugin's lifecycle method will be exposed to downstream dependencies when their corresponding lifecycle methods are invoked.

## Classes

|  Class | Description |
|  --- | --- |
|  [ToastsApi](./kibana-plugin-public.toastsapi.md) |  |
|  [UiSettingsClient](./kibana-plugin-public.uisettingsclient.md) |  |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [ApplicationSetup](./kibana-plugin-public.applicationsetup.md) |  |
|  [ApplicationStart](./kibana-plugin-public.applicationstart.md) |  |
|  [Capabilities](./kibana-plugin-public.capabilities.md) | The read-only set of capabilities available for the current UI session. Capabilities are simple key-value pairs of (string, boolean), where the string denotes the capability ID, and the boolean is a flag indicating if the capability is enabled or disabled. |
|  [ChromeBadge](./kibana-plugin-public.chromebadge.md) |  |
|  [ChromeBrand](./kibana-plugin-public.chromebrand.md) |  |
|  [ChromeBreadcrumb](./kibana-plugin-public.chromebreadcrumb.md) |  |
|  [ChromeNavControl](./kibana-plugin-public.chromenavcontrol.md) |  |
|  [ChromeNavControls](./kibana-plugin-public.chromenavcontrols.md) | [APIs](./kibana-plugin-public.chromenavcontrols.md) for registering new controls to be displayed in the navigation bar. |
|  [ChromeNavLink](./kibana-plugin-public.chromenavlink.md) |  |
|  [ChromeNavLinks](./kibana-plugin-public.chromenavlinks.md) | [APIs](./kibana-plugin-public.chromenavlinks.md) for manipulating nav links. |
|  [ChromeRecentlyAccessed](./kibana-plugin-public.chromerecentlyaccessed.md) | [APIs](./kibana-plugin-public.chromerecentlyaccessed.md) for recently accessed history. |
|  [ChromeRecentlyAccessedHistoryItem](./kibana-plugin-public.chromerecentlyaccessedhistoryitem.md) |  |
|  [ChromeStart](./kibana-plugin-public.chromestart.md) | ChromeStart allows plugins to customize the global chrome header UI and enrich the UX with additional information about the current location of the browser. |
|  [CoreSetup](./kibana-plugin-public.coresetup.md) | Core services exposed to the <code>Plugin</code> setup lifecycle |
|  [CoreStart](./kibana-plugin-public.corestart.md) | Core services exposed to the <code>Plugin</code> start lifecycle |
|  [DocLinksStart](./kibana-plugin-public.doclinksstart.md) |  |
|  [ErrorToastOptions](./kibana-plugin-public.errortoastoptions.md) |  |
|  [FatalErrorInfo](./kibana-plugin-public.fatalerrorinfo.md) | Represents the <code>message</code> and <code>stack</code> of a fatal Error |
|  [FatalErrorsSetup](./kibana-plugin-public.fatalerrorssetup.md) | FatalErrors stop the Kibana Public Core and displays a fatal error screen with details about the Kibana build and the error. |
|  [HttpInterceptor](./kibana-plugin-public.httpinterceptor.md) |  |
|  [HttpServiceBase](./kibana-plugin-public.httpservicebase.md) |  |
|  [I18nStart](./kibana-plugin-public.i18nstart.md) | I18nStart.Context is required by any localizable React component from @<!-- -->kbn/i18n and @<!-- -->elastic/eui packages and is supposed to be used as the topmost component for any i18n-compatible React tree. |
|  [LegacyNavLink](./kibana-plugin-public.legacynavlink.md) |  |
|  [NotificationsSetup](./kibana-plugin-public.notificationssetup.md) |  |
|  [NotificationsStart](./kibana-plugin-public.notificationsstart.md) |  |
|  [OverlayRef](./kibana-plugin-public.overlayref.md) |  |
|  [OverlayStart](./kibana-plugin-public.overlaystart.md) |  |
|  [Plugin](./kibana-plugin-public.plugin.md) | The interface that should be returned by a <code>PluginInitializer</code>. |
|  [PluginInitializerContext](./kibana-plugin-public.plugininitializercontext.md) | The available core services passed to a <code>PluginInitializer</code> |
|  [UiSettingsState](./kibana-plugin-public.uisettingsstate.md) |  |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [ChromeHelpExtension](./kibana-plugin-public.chromehelpextension.md) |  |
|  [ChromeNavLinkUpdateableFields](./kibana-plugin-public.chromenavlinkupdateablefields.md) |  |
|  [HttpSetup](./kibana-plugin-public.httpsetup.md) |  |
|  [HttpStart](./kibana-plugin-public.httpstart.md) |  |
|  [PluginInitializer](./kibana-plugin-public.plugininitializer.md) | The <code>plugin</code> export at the root of a plugin's <code>public</code> directory should conform to this interface. |
|  [RecursiveReadonly](./kibana-plugin-public.recursivereadonly.md) |  |
|  [ToastInput](./kibana-plugin-public.toastinput.md) |  |
|  [UiSettingsClientContract](./kibana-plugin-public.uisettingsclientcontract.md) | [UiSettingsClient](./kibana-plugin-public.uisettingsclient.md) |

